;CELTIC revision 3 by Iambian Zenith (Rodger Weisman)
;Reported version 3.08
SUBVERSION   .equ 08
;=========================================================
;DEFINES FOR PROGRAM MANAGEMENT
;===== Debugging modes
CDEBUG       .equ 0  ;1=enable 0=disable || debug mode. Uses serious memory.
FDEBUG       .equ 0  ;1=enable 0=disable || lists function sizes inline
RDEBUG       .equ 0  ;1=enable 0=disable || lists routine short names
SDEBUG       .equ 0  ;1=enable 0=disable || lists routine sizes inline

;===== Error system
ERRSYS       .equ 1  ;1=8char 2=2char 3=omit
NOERROR      .equ 0  ;1=Minimal error checking 0=Full error checking

;===== File searching
FILEAPPVAR   .equ 1  ;1=EnableAppVarSearch 0=Disable
FILELCASE    .equ 1  ;1=EnableLowercaseConversion 0=Disable
FILEHIDDEN   .equ 1  ;1=EnableHiddenFileSearch 0=Disable
FILEGROUP    .equ 0  ;Autoset when group serach feature is needed.

;=====Main routine features
FEATURESET      .equ 1  ;Cannot be disabled || command 00 CHK VERIFIED
LINEREAD        .equ 1  ;1=enable 0=disable || command 01 CHK VERIFIED
LINEWRITE       .equ 1  ;1=enable 0=disable || command 02 CHK VERIFIED
LINEERASE       .equ 1  ;1=enable 0=disable || command 03 CHK VERIFIED
LINEREPLACE     .equ 1  ;1=enable 0=disable || command 04 CHK VERIFIED
TOGGLEARC       .equ 1  ;1=enable 0=disable || command 05 CHK VERIFIED
TOKENCODE       .equ 1  ;1=enable 0=disable || command 06 CHK VERIFIED
DELETEPROG      .equ 1  ;1=enable 0=disable || command 07 CHK VERIFIED
OUTPUTSTATS     .equ 1  ;1=enable 0=disable || command 08 CHK VERIFIED
TOGGLELOCK      .equ 1  ;1=enable 0=disable || command 09 CHK VERIFIED
TOGGLEHIDE      .equ 1  ;1=enable 0=disable || command 0A CHK VERIFIED
FINDPROG        .equ 1  ;1=enable 0=disable || command 0B CHK VERIFIED
CREATEPROG      .equ 1  ;1=enable 0=disable || command 0C CHK VERIFIED
UNGROUPFILE     .equ 1  ;1=enable 0=disable || command 0D CHK VERIFIED
GETGROUP        .equ 1  ;1=enable 0=disable || command 0E CHK VERIFIED
EXTGROUP        .equ 1  ;1=enable 0=disable || command 0F CHK VERIFIED
TOGGLEAVAR      .equ 1  ;1=enable 0=disable || command 10 CHK VERIFIED
BINREAD         .equ 1  ;1=enable 0=disable || command 11 CHK VERIFIED
BINWRITE        .equ 1  ;1=enable 0=disable || command 12 CHK VERIFIED
BINDELETE       .equ 1  ;1=enable 0=disable || command 13 CHK VERIFIED
PROGTOSTRING    .equ 1  ;1=enable 0=disable || command 14 CHK VERIFIED

;=====Subroutine equate settings
RMAKESTRING     .equ 0  ;Set to disable until .set encountered
RGETSTR9        .equ 0  ;Set to disable until .set encountered
RGETPROGRAMNAME .equ 0  ;Set to disable until .set encountered
RGETPROGRAM     .equ 0  ;Set to disable until .set encountered
RGETHLINC       .equ 0  ;Set to disable until .set encountered
RINCHL          .equ 0  ;Set to disable until .set encountered
RADDDETOHL      .equ 0  ;Set to disable until .set encountered
RGETPROGANDANS  .equ 0  ;Set to disable until .set encountered
RGETANS         .equ 0  ;Set to disable until .set encountered
RGETTHETA       .equ 0  ;Set to disable until .set encountered
RFINDLINE       .equ 0  ;Set to disable until .set encountered
RGETLINE        .equ 0  ;Set to disable until .set encountered
RCONVERTTTOH    .equ 0  ;Set to disable until .set encountered
RCONVERTSUMSUB  .equ 0  ;Set to disable until .set encountered
RCONVERTSUB     .equ 0  ;Set to disable until .set encountered
RTEXTNUMINA     .equ 0  ;Set to disable until .set encountered
RCONVERTHTOT1B  .equ 0  ;Set to disable until .set encountered
RCONVERTHTOT2B  .equ 0  ;Set to disable until .set encountered
RCONVERTHTOTSUB .equ 0  ;Set to disable until .set encountered
RNUMTEXTINA     .equ 0  ;Set to disable until .set encountered
RFASTCOPY       .equ 0  ;Set to disable until .set encountered
RGETSIZE        .equ 0  ;set to disable until .set encountered
RGROUPHANDLER   .equ 0  ;set to disable until .set encountered
RLOOKUPEOF      .equ 0  ;set to disable until .set encountered
RCONVHLTODEC    .equ 0  ;set to disable until .set encountered
RUPDATESIZE     .equ 0  ;set to disable until .set encountered
RCONVOP1B       .equ 0  ;set to disable until .set encountered

;END DEFINES
;=========================================================
;Program control block

#IF CDEBUG = 1
#DEFINE DEBUG .db $CD \ .dw debug0 ; CALL DEBUG
RCONVERTHTOT2B   .set 1
RFASTCOPY        .set 1
.ECHO "DEBUG MODE ENABLED\n"
#ELSE
#DEFINE DEBUG ;Null define; strip debug call from code
#ENDIF

#include "ti83plus.inc"
.org $9D93
.dw  $6DBB
myflag equ asm_flag1
HitEOF equ 0  ;EOF during getnextline reached
HitSOF equ 1  ;SOF during getprevline reached
HitEOL equ 2  ;End of line encountered
ConEOF equ 3  ;Set if trying to read after HitEOL is set.
FirstL equ 4  ;Ignore the first byte being read
Delete equ 5  ;Set to delete information only
Hidden equ 6  ;is set if variable is "hidden"
gGroup equ 7  ;set to enable get group name
temp1  equ appbackupscreen+00
temp2  equ appbackupscreen+02
SOF    equ appbackupscreen+04  ;2adr,1pg,1buf. start of file
EOF    equ appbackupscreen+08  ;ditto above. end of file
curpos equ appbackupscreen+12  ;... current cursor position. +3=0 if in RAM
page   equ appbackupscreen+16  ;Page number for when exiting or for var in arc
stack  equ appbackupscreen+17  ;2b stack address for restoring at end of prog
pline  equ appbackupscreen+19  ;2adr,1pg,1buf. Position of previously read line
memdel equ appbackupscreen+23  ;2bytes. Amount of data deleted
memins equ appbackupscreen+25  ;2bytes. Amount of data inserted. To be compared.
temp3  equ appbackupscreen+27  ;2bytes. Temporary memory
gSOF   equ appbackupscreen+29  ;4bytes. Address of grouped start of file + page
gEOF   equ appbackupscreen+33  ;4bytes. Address of grouped end of file + page
gSIZE  equ appbackupscreen+37  ;2bytes. Size of the grouped entry
nsize  equ appbackupscreen+39  ;1byte. Size of name entry in OP1. Excludes type
ipart  equ appbackupscreen+40  ;2bytes. Imaginary part to any complex part input
tstrn  equ appbackupscreen+42  ;5bytes. Temporary storage of 5-digit number

.echo "ENABLED : "
#IF CDEBUG = 1
.echo "DBUG "
#ENDIF
RGETTHETA       .set 1      ;
programstart:
 di
 ld (stack),SP
 in a,(6)
 ld (page),a
 ld hl,0
 ld (ipart),hl
 ld hl,programend
 push hl         ;place exiting call onto stack
 ld (IY+myflag),00000010b
 call gettheta
 jp z,fFeatureList
 dec e  ;chk 1              |
;LINEREAD ENABLE/DISABLE=====
#IF LINEREAD = 1            ;
.echo "LNRD "               ;
 jp z,fLineRead             ;
RGETLINE        .set 1      ;
RMAKESTRING     .set 1      ;
RINCHL          .set 1      ;
RGETPROGRAM     .set 1      ;
RFINDLINE       .set 1      ;
#ENDIF                      ;
;============================
 dec e  ;chk 2              |
;LINEWRITE ENABLE/DISABLE====
#IF LINEWRITE = 1           ;
.echo "LNWR "               ;
 jp z,fLineWrite            ;
RGETLINE        .set 1      ;
RGETSTR9        .set 1      ;
RGETPROGRAM     .set 1      ;
RUPDATESIZE     .set 1      ;
#ENDIF                      ;
;============================
 dec e  ;chk 3              |
;LINEERASE ENABLE/DISABLE====
#IF LINEERASE = 1           ;
.echo "LNER "               ;
 jp z,fLineErase            ;
RGETPROGRAM     .set 1      ;
RGETLINE        .set 1      ;
RUPDATESIZE     .set 1      ;
#ENDIF                      ;
;============================
 dec e  ;chk 4              |
;LINEREPLACE ENABLE/DISABLE==
#IF LINEREPLACE = 1         ;
.echo "LNRE "               ;
 jp z,fLineReplace          ;
RGETPROGRAM     .set 1      ;
RGETLINE        .set 1      ;
RGETSTR9        .set 1      ;
RUPDATESIZE     .set 1      ;
#ENDIF                      ;
;============================
 dec e  ;chk 5              |
;TOGGLEARC ENABLE/DISABLE====
#IF TOGGLEARC = 1           ;
.echo "TARC "               ;
 jp z,fToggleArc            ;
RGETPROGRAMNAME .set 1      ;
#ENDIF                      ;
;============================
 dec e  ;chk 6              |
;TOKENCODE ENABLE/DISABLE====
#IF TOKENCODE = 1           ;
.echo "TOKC "               ;
 jp z,fTokenCode            ;
RMAKESTRING     .set 1      ;
RGETANS         .set 1      ;
#ENDIF                      ;
;============================
 dec e  ;chk 7              |
;DELETEPROG ENABLE/DISABLE===
#IF DELETEPROG = 1          ;
.echo "DELP "               ;
 jp z,fDeleteProg           ;
RGETPROGRAMNAME .set 1      ;
#ENDIF                      ;
;============================
 dec e  ;chk 8              |
;OUTPUTSTATS ENABLE/DISABLE==
#IF OUTPUTSTATS = 1         ;
.echo "OUST "               ;
 jp z,fOutputStats          ;
FILEGROUP       .set 1      ;
RMAKESTRING     .set 1      ;
RGETPROGRAM     .set 1      ;
RCONVHLTODEC    .set 1      ;
#ENDIF                      ;
;============================
 dec e  ;chk 9              |
;TOGGLELOCK ENABLE/DISABLE===
#IF TOGGLELOCK = 1          ;
.echo "TGLK "               ;
 jp z,fToggleLock           ;
RGETPROGRAMNAME .set 1      ;
#ENDIF                      ;
;============================
 dec e  ;chk 10             |
;TOGGLEHIDE ENABLE/DISABLE===
#IF TOGGLEHIDE = 1          ;
.echo "TGHD "               ;
 jp z,fToggleHide           ;
RGETPROGRAMNAME .set 1      ;
#ENDIF                      ;
;============================
 dec e  ;chk 11             |
;FINDPROG ENABLE/DISABLE=====
#IF FINDPROG = 1            ;
.echo "FNDP "               ;
 jp z,fFindProg             ;
RMAKESTRING     .set 1      ;
RGETPROGRAM     .set 1      ;
#ENDIF                      ;
;============================
 dec e  ;chk 12             |
;CREATEPROG ENABLE/DISABLE===
#IF CREATEPROG = 1          ;
.echo "CRPR "               ;
 jp z,fCreateProg           ;
RGETPROGRAMNAME .set 1      ;
#ENDIF                      ;
;============================
 dec e  ;chk 13             |
;CREATEPROG ENABLE/DISABLE===
#IF UNGROUPFILE = 1         ;
.echo "UNGF "               ;
 jp z,fUngroupFile          ;
FILEGROUP       .set 1      ;
RGETPROGRAMNAME .set 1      ;
#ENDIF                      ;
;============================
 dec e  ;chk 14             |
;GETGROUP ENABLE/DISABLE=====
#IF GETGROUP = 1            ;
.echo "GETG "               ;
 jp z,fGetGroup             ;
FILEGROUP     .set 1        ;
RMAKESTRING   .set 1        ;
RGROUPHANDLER .set 1        ;
RGETPROGRAM   .set 1        ;
RLOOKUPEOF    .set 1        ;
#ENDIF                      ;
;============================
 dec e  ;chk 15             |
;EXTGROUP ENABLE/DISABLE=====
#IF EXTGROUP = 1            ;
.echo "EXTG "               ;
 jp z,fExtGroup             ;
FILEGROUP     .set 1        ;
RGETANS       .set 1        ;
RMAKESTRING   .set 1        ;
RGROUPHANDLER .set 1        ;
RGETPROGRAM   .set 1        ;
RLOOKUPEOF    .set 1        ;
#ENDIF                      ;
;============================
 dec e  ;chk 16             |
;TOGGLEAVAR ENABLE/DISABLE===
#IF TOGGLEAVAR = 1          ;
.echo "TAVR "               ;
 jp z,fToggleAVAR           ;
RGETPROGRAMNAME .set 1      ;
#ENDIF                      ;
;============================
 dec e  ;chk 17             |
;BINREAD ENABLE/DISABLE======
#IF BINREAD = 1             ;
.echo "BNRD "               ;
 jp z,fBinRead              ;
RGETPROGRAM     .set 1      ;
RGETANS         .set 1      ;
RMAKESTRING     .set 1      ;
RCONVERTHTOT1B  .set 1      ;
RGETHLINC       .set 1      ;
#ENDIF                      ;
;============================
 dec e  ;chk 18             |
;BINWRITE ENABLE/DISABLE=====
#IF BINWRITE = 1            ;
.echo "BNWR "               ;
 jp z,fBinWrite             ;
RGETPROGRAM     .set 1      ;
RUPDATESIZE     .set 1      ;
RGETANS         .set 1      ;
RGETSTR9        .set 1      ;
RTEXTNUMINA     .set 1      ;
#ENDIF                      ;
;============================
 dec e  ;chk 19             |
;BINDELETE ENABLE/DISABLE====
#IF BINDELETE = 1           ;
.echo "BNDL "               ;
 jp z,fBinDelete            ;
RGETPROGRAM     .set 1      ;
RUPDATESIZE     .set 1      ;
RGETANS         .set 1      ;
#ENDIF                      ;
;============================
 dec e  ;chk 20             |
;PROGTOSTRING ENABLE/DISABLE=
#IF PROGTOSTRING = 1        ;
.echo "P2S9 "               ;
 jp z,fProgToString         ;
RGETPROGRAM     .set 1      ;
RMAKESTRING     .set 1      ;
#ENDIF                      ;
;============================
;END SECTION                |
 jp Err.NoSupport           ;
;--------------------------/|
.echo "\n"
;============================
;============================
fFeatureList:               ;
 ld hl,(fFeatureList0-2)    ;
 call makestring+3          ;
 ld hl,fFeatureList0        ;
 ldir                       ;
 ret                        ;
                            ;
.dw fFeatureList1-fFeatureList0
#DEFINE SUBVERSIONLSB ( SUBVERSION % 10 ) + $30
#DEFINE SUBVERSIONMSB ( ( SUBVERSION - (  SUBVERSIONLSB - $30 ) ) / 10 ) + $30
fFeatureList0:              ;
.db SUBVERSIONMSB           ;
.db SUBVERSIONLSB           ;
;CELTIC III INTERNAL STATUS ;
.db ERRSYS + $30            ;
.db $30 + ( FILEAPPVAR << 0 ) + ( FILELCASE << 1 ) + ( FILEHIDDEN << 2 )
;CELTIc III MODULE STATUS   ;
.db LINEREAD + $30          ;
.db LINEWRITE + $30         ;
.db LINEERASE + $30         ;
.db LINEREPLACE + $30       ;
.db TOGGLEARC + $30         ;
.db TOKENCODE + $30         ;
.db DELETEPROG + $30        ;
.db OUTPUTSTATS + $30       ;
.db TOGGLELOCK + $30        ;
.db TOGGLEHIDE + $30        ;
.db FINDPROG + $30          ;
.db CREATEPROG + $30        ;
.db UNGROUPFILE + $30       ;
.db GETGROUP + $30          ;
.db EXTGROUP + $30          ;
.db TOGGLEAVAR + $30        ;
.db BINREAD + $30           ;
.db BINWRITE + $30          ;
.db BINDELETE + $30         ;
.db PROGTOSTRING + $30      ;
fFeatureList1:              ;
;============================
.echo "Inital Code: "
.echo $-programStart
.echo " bytes\n"
programMiddle:
;============================
#IF LINEREAD == 1
fLineRead:
 call getLine
 jr nc,$+11
 bit ConEOF,(iy+myflag)
 jp nz,Err.LINENOTFOUND
 jr fGetLineNum
 ld a,b
 or c
 jp z,Err.NULLLINE
 ld h,b
 ld l,c
 call makestring+3
 push de
  call getLine
 pop de
 ld hl,(pLine)
 ld a,(pLine+2)
 out (6),a
 ld a,(hl)
 ld (de),a
 inc de
 call IncHL
 dec bc
 ld a,b
 or c
 jr nz,$-9
 jp programEnd
fGetLineNum:
 call getprogram
 ex de,hl            ;DE taken for addy, HL used for counter.
 ld hl,$0000
fGetLineNum0:
 push hl
  call findLine
 pop hl
 inc hl
 bit HitEOF,(iy+myflag)
 jr z,fGetLineNum0
 bcall(_SetXXXXOp2)
 bcall(_Op2toOp1)
 bcall(_ZeroOp2)
 bcall(_StoTheta)
 jp Err.NUMSTRING
#IF FDEBUG=1
.echo "CMD01 "
.echo $-fLineRead
.echo ", "
#ENDIF 
#ENDIF
;============================
#IF LINEWRITE == 1
fLineWrite:
 call getprogram
 in a,(6)
 or a
 jp nz,Err.PRGMARCHIVED
 call getLine
 jp c,Err.LINENOTFOUND
 call getStr9
 jp z,Err.NULLSTRING
 ld de,(pLine)       ;getting pointer to start of line
 inc bc              ;increment to accomodate for tENTER appended.
 ld h,b              ;loading to HL for insert mem size
 ld l,c              ;...
 push hl
  push bc
   push de
    bcall(_EnoughMem)
    jp c,Err.NOMEM
   pop de
  pop bc
 pop hl
 push hl             ;DE is already set to address of insertion
  bcall(_InsertMem)  ;insert the memory
 pop bc
 call updatesizeins
 push de
  call getStr9        ;get the string variable again. It's HL is address to copy
 pop de
 ldir                ;copy string
 ld a,tEnter         ;loading up tENTER
 ld (de),a           ;append tENTER
 ret
#IF FDEBUG=1
.echo "CMD02 "
.echo $-flinewrite
.echo ", "
#ENDIF 
#ENDIF
;============================
#IF LINEERASE == 1
fLineErase:
 call getprogram        ;get vectors
 in a,(6)               ;check page
 or a                   ;checking
 jp nz,Err.PRGMARCHIVED ;error if archived
 call getLine           ;get line address, store to (pLine)
 jp c,Err.LINENOTFOUND  ;If carry invoked, (pLine) has nothing useful
 bit HitEOF,(iy+myflag) ;check to see if last line was hit
 jr nz,$+3              ;if so, jump over since no NewLine char is there
 inc bc                 ;increment to include tENTER
 ld a,b                 ;Check line size.
 or c                   ;checking
 ret z                  ;Quit routine if zero.
 ld hl,(pLine)          ;Address in DE
 ld d,b                 ;Amount in  HL
 ld e,c                 ;...
 push bc                ;Preserve size
  bcall(_DelMem)        ;Delete memory, DE=adr, HL=bytes
 pop bc                 ;get back size
 jp updatesizedel       ;update size then RET
#IF FDEBUG=1
.echo "CMD03 "
.echo $-flineerase
.echo ", "
#ENDIF 
#ENDIF
;============================
#IF LINEREPLACE == 1
fLineReplace:
 call getprogram        ;out: hl=address, bc=size
 in a,(6)               ;check if...
 or a                   ;is archived
 jp nz,Err.PRGMARCHIVED ;quit if archived. Can't edit archived vars.
 call getLine           ;get line. (pline)=start of line
 jp c,Err.LINENOTFOUND  ;error conditions do not allow proper editing
 push bc                ;save length of the string to remove
  call getStr9          ;get the length of the line to replace with
  ld h,b                ;put this into HL. We'll be comparing with this
  ld l,c                ;...
  jp z,Err.NULLSTRING   ;Nevermind the load. If this was zero, replace with nothing.
 pop de                 ;restore with size to remove.
 push hl                ;save the size of the string
  sbc hl,de              ;Size of replacement - size to remove. HL contains size change
  push hl                ;preserve the change in program size
   jr c,$+10             ;if the removal was of greater size, don't check mem.
   push de               ;preserve bytes to delete
    bcall(_EnoughMem)    ;check if the addition of HL bytes is enough
   pop de                ;restore bytes to delete
   jp c,Err.NOMEM        ;if not, then kill the routine.
   ld hl,(pline)         ;loading with address to remove data
   push hl               ;save address of deletion
    bcall(_DelMem)       ;remove memory from program, including possible ending newline
   pop de                ;restore address deleted from in DE
  pop bc                 ;restore change in program size. Not needed right now.
 pop hl                  ;restore size of the string
 push bc                 ;save (again) the change in program size
  bcall(_InsertMem)      ;insert that memory
 pop bc                  ;restore the change in the program size
 call updatesizeins      ;update the size of the file (BC)
 call getstr9            ;get contents of str9, HL=address, BC=size
 ld de,(pline)           ;address of insertion point
 ldir                    ;copy string to program
 ret                     ;exit routine
#IF FDEBUG=1
.echo "CMD04 "
.echo $-flinereplace
.echo ", "
#ENDIF 
#ENDIF
;============================
#IF TOGGLEARC == 1
fToggleArc:
 call getprogramname
 jp c,Err.PRGMNOTFOUND
 bcall(_Arc_Unarc)
 ret
#IF FDEBUG=1
.echo "CMD05 "
.echo $-ftogglearc
.echo ", "
#ENDIF 
#ENDIF
;============================
#IF TOKENCODE == 1
fTokenCode:
 call getAns
 ld a,(ipart)
 ld d,a
 push de
  ld hl,1
  ld a,d
  or a
  jr z,$+3
  inc hl
  call makestring+3
 pop hl
 ex de,hl
 ld (hl),e
 ld a,d
 or a
 jr z,$+4
 inc hl
 ld (hl),d
 ret
#IF FDEBUG=1
.echo "CMD06 "
.echo $-fTokencode
.echo ", "
#ENDIF 
#ENDIF
;============================
#IF DELETEPROG == 1
fDeleteProg:
 call getprogramname
 jp c,Err.PRGMNOTFOUND
 bcall(_DelVarArc)
 ret
#IF FDEBUG=1
.echo "CMD07 "
.echo $-fdeleteprog
.echo ", "
#ENDIF 
#ENDIF
;============================
#IF OUTPUTSTATS = 1
fOutputStats:
;output: "1234XXXXX"
;1= A/R Arc/RAM
;2= H/V   Hidden/Visible
;3= L/W/P Lock/Writable/appvar
;4= Reserved (space)
;XXXXX = five digit size
;
 set gGroup,(iy+myflag)
 ld hl,8
 call makestring+3  ;output: DE=addy
 push de
  call getprogram
 pop hl
 in a,(6)
 ld bc,$4152 ;C='A' B='R'
 jp p,$+5
 ld b,'E'    ;If in ExRAM, "E"
 or a
 call LoadBIncOnZero
 ld bc,$4856 ;'V'+(256*'H')
 bit Hidden,(IY+myflag)
 call LoadBIncOnZero
 ld a,(Op1)
 ld bc,$4C57 ;'L'+(256*'W')
 cp $05
 call LoadBIncOnZero
 ex de,hl  ;DE=addressOfString, HL=size
 call convHLtoDec
 ret
LoadBIncOnZero:
 ld (hl),c
 jr z,$+3
 ld (hl),b
 inc hl
 ret
#IF FDEBUG=1
.echo "CMD08 "
.echo $-foutputstats
.echo ", "
#ENDIF 
#ENDIF
;============================
#IF TOGGLELOCK == 1
fToggleLock:
 call getprogramname
 jp c,Err.PRGMNOTFOUND
 cp AppVarObj
 ret z
 inc a
 cp 7
 jr nz,$+4
 ld a,5
 ld (hl),a
 ret
#IF FDEBUG=1
.echo "CMD09 "
.echo $-fTogglelock
.echo ", "
#ENDIF 
#ENDIF
;============================
#IF TOGGLEHIDE == 1
fToggleHide:
 call getprogramname
 jp c,Err.PRGMNOTFOUND
 ld de,-7
 add hl,de
 ld a,$40
 cp (hl)
 jr nc,$+4
 ld a,-$40
 add a,(hl)
 ld (hl),a
 ret
#IF FDEBUG=1
.echo "CMD10 "
.echo $-ftogglehide
.echo ", "
#ENDIF 
#ENDIF
;============================
#IF FINDPROG = 1
fFindProg:
 ld hl,ProgramEnd
 push hl
ProgFind:
 call initFindProg
 ld hl,0
ProgFindLoop1:
 call checkVATEnd
 jr c,ProgFindEndL1
 push hl
  call startFindProg
 pop hl
 jr c,ProgFindLoop1
 inc hl    ;for added space
 add hl,bc
 jr ProgFindLoop1
ProgFindEndL1:
 ld a,h
 or L
 jp z,Err.NULLVAR
 call makestring+3
 push de
  call initFindProg
 pop hl
ProgFindLoop:
 call checkVATEnd
 ret c
 push hl       ;save address of the output string
  call startFindProg  ;serach for program information
 pop hl        ;restore address of the output string
 jr c,ProgFindLoop
 ex de,hl      ;putting in DE address to write to
 ld hl,Op1     ;reading from OP1
 ld a,(hl)     ;loading type byte from OP1
 cp AppVarObj  ;check if appvar type
 jr z,$+3      ;if so, then skip increment to not write type byte in
 inc hl        ;if anything other than appvar, then increment to not include type
 ldir          ;block copy
 ex de,hl      ;put writing pointer back into HL
 ld (hl),$29   ;write space token into file
 inc hl        ;move pointer up one more
 jr ProgFindLoop ;loop back to the program find loop

initFindProg:
 ld hl,(progPtr)  ;location of start of prog VAT
 ld (temp1),hl    ;(temp1) = VAT position
 ld hl,Str0
 call getStr9+3
 ld (temp2),hl    ;(temp2) = string location
 ld (pLine),bc    ;(pLine) = recycled pointer for size.
 ret

checkVATEnd:
 ld de,(temp1)
 ld a,(pTemp)
 sub e
 ld a,(pTemp+1)
 sbc a,d
 ccf
 ret
 pop bc
sfpFail:
 xor a
 ld c,a
 scf
 ret
startFindProg: ;two errors. carry=EOV, C=0 for no entry (try again)
 ex de,hl      ;put the pointer to the VAt into HL
 ld de,Op1     ;put beginning of the destination into DE for manual LDI
 ld a,(hl)     ;load filetype byte into A for comparison
 ld (de),a     ;but it is copied into (DE) before anything is done.
 inc de        ;increment pointer to copy to align to name
 push af
  ld bc,-6     ;skip past data to get to the name information of VAT entry
  add hl,bc    ;perform addition
  ld c,(hl)    ;load size information to register C
  ld b,c       ;backup register C to B for use
  dec hl       ;decrement HL to move it to start of the name information
  ld a,(hl)    ;retrieve byte of name
  ld (de),a    ;store that byte into OP1 space
  dec hl       ;move down to next byte of the name
  inc de       ;increment to write next byte of the name
  djnz $-4     ;loop back using stored B in previous operation
  ld (temp1),hl ;store next VAT position entry back into current pointer
  xor a        ;clear register A
  ld (de),a    ;and null-terminate the string, in case it's not 8 characters long
 pop af       ;performing filetype test after this.
 sub $05      ;/do not pass through if not correct type
 jr z,$+10    ;|jump past any further testing. We have correct type.
 dec a        ;|check for protprog object
 jr z,$+7     ;|jump past further testing.
 inc c        ;|increment namespace size for appvar type
 cp $15-$06   ;|check for appvar type
 jr nz,sfpFail
 push bc              ;save the contents of the size information
  bcall(_ChkFindSym)  ;use the contents of string to perform lookup
  call getprogram+3   ;loads up info for reading. (A):HL=SOF
  ld bc,(pLine)       ;Str0 size
  ld de,(temp2)       ;Str0 location
  ld a,b              ;start checking...
  or c                ;checking if BC=0
  jr z,strtFndProgEnd ;skip testing on null string, user wants all progs
  ld a,(de)           ;loading up first byte of the string in RAM
  cp (hl)             ;comparing up the first byte of program
  jr nz,sfpFail-1     ;if no match, then jump to routine exit
  inc de              ;increment DE
  call IncHL          ;increment (6):HL
  dec bc              ;decrement BC
  ld a,b              ;checking if
  or c                ;BC == 0
  jr nz,$-11          ;continue looping if there are more letters to test
strtFndProgEnd:
 pop bc              ;remove stack
 ret                 ;Op1=name, C=name length only

#IF FDEBUG=1
.echo "CMD11 "
.echo $-ffindprog
.echo ", "
#ENDIF 
#ENDIF
;============================
#IF CREATEPROG == 1
fCreateProg:
 call getprogramname
 jp nc,Err.PRGMFOUND
 ld hl,0
 ld a,(Op1)
 and $1F
 cp $15
 jr z,$+6
 bcall(_CreateProg)
 ret
 bcall(_CreateAppVar)
 ret
#IF FDEBUG=1
.echo "CMD12 "
.echo $-fcreateprog
.echo ", "
#ENDIF 
#ENDIF
;============================
#IF UNGROUPFILE = 1
fUngroupFile:
 set gGroup,(iy+myflag)
 call getprogramname
 jp c,Err.GROUPNOTFOUND
 ld a,(Op1)
 cp $17
 jp nz,Err.GROUPNOTFOUND
 bcall($50C8)    ;UngroupVar undoc'ed romcall
 res curLock,(iy+curFlags)
 ret
#IF FDEBUG=1
.echo "CMD13 "
.echo $-fungroupfile
.echo ", "
#ENDIF 
#ENDIF
;============================
#IF GETGROUP = 1
fGetGroup:
 set gGroup,(iy+myflag)
 call getprogram
 ld bc,0
getgrouploop:
 call lookupEOF
 jr c,buildgrpstr
 push bc
  call groupgetnext
 pop bc
 jr c,getgrouploop
 ld a,(nsize)
 inc a
 add a,c
 ld c,a
 jr nc,$+3
 inc b
 ld a,(Op2)
 cp AppVarObj
 jr nz,getgrouploop
 inc bc
 jr getgrouploop
buildgrpstr:
 ld h,b
 ld l,c
 call makestring+3
 push de
  call getprogram
 pop de
getgrouploop2:
 push de
  call lookupEOF
 pop de
 ret c
 push de
  call groupgetnext
 pop de
 jr c,getgrouploop2
 ld bc,(nsize)
 push hl
  ld hl,Op2
  ld a,(hl)
  inc hl
  cp AppVarObj
  jr nz,$+4
  inc c
  dec hl
  ld b,0
  ldir
  ld a,$29
  ld (de),a
  inc de
 pop hl
 jr getgrouploop2
#IF FDEBUG=1
.echo "CMD14 "
.echo $-fgetgroup
.echo ", "
#ENDIF 
#ENDIF
;============================
#IF EXTGROUP = 1
fExtGroup:
 set gGroup,(iy+myflag)
 call getans
 push de
  call getprogram
 pop de
ExtGrItLoop:
 push de
  call lookupEOF
 pop de
 jp c,Err.PRGMNOTFOUND
 push de
  call groupgetnext
 pop de
 jr c,ExtGrItLoop
 dec de
 ld a,d
 or e
 jr nz,ExtGrItLoop
ExtGrItCont:
 bcall(_Op2toOp1)
 bcall(_ChkFindSym)
 jp nc,Err.PRGMFOUND
 ld hl,(gSIZE)
 push hl
  ld a,(Op1)
  cp AppVarObj
  jr z,$+7
  bcall(_CreateProg)
  jr $+5
  bcall(_CreateAppVar)
  inc de
  inc de
  ld hl,(gSOF)
 pop bc
 ld a,(gSOF+2)
 out (6),a
 call GetHLInc
 ld (de),a
 inc de
 dec bc
 ld a,b
 or c
 jr nz,$-8
 ret
#IF FDEBUG=1
.echo "CMD15 "
.echo $-fextgroup
.echo ", "
#ENDIF 
#ENDIF
;============================
#IF TOGGLEAVAR = 1
fToggleAVAR:
 call getprogramname
 jp c,Err.PRGMNOTFOUND
 cp AppVarObj      ;check for appvarobj
 jr z,$+6         ;if so, convert to prog
 ld (hl),AppvarObj ;convert to appvarobj
 jr $+4            ;jump past second conversion
 ld (hl),progObj   ;convert to program object
 ret
#IF FDEBUG=1
.echo "CMD16 "
.echo $-ftoggleavar
.echo ", "
#ENDIF 
#ENDIF
;============================
#IF BINREAD == 1
fBinRead:
 call getans         ;get: DE=from nth byte, (ipart)=Y bytes forward
 ld (temp1),de       ;load DE to temporary var
 ld hl,(ipart)       ;get Y
 ld a,l              ;check
 or h                ;if zero
 jp z,Err.NULLVAR    ;If zero, then error condition; not reading any bytes
 push hl             ;store # of bytes to read
  add hl,hl          ;double this for string recall creation
  call makestring+3  ;create Str9 with as many bytes as hex digits
  push de            ;save position of string
   call getprogram   ;locate program variable
   ld de,(temp1)     ;store back nth byte
   call AddDEtoHL    ;get position to start reading from
  pop de             ;restore position of the string
 pop bc              ;restore # of bytes to read as BC for looping
BinReadLoop:         ;start of loop
 call getHLInc       ;get data from file and increment pointer
 push hl             ;preserve address
  call convertHtoT1b ;call conversion routine to convert A to hex text
  ld hl,Op6          ;which happens to be in Op6
  inc bc             ;increment to counteract the two decrements by LDI
  ldi                ;copy byte to string (DE)
  ldi                ;copy another byte to complete writing one "byte"
 pop hl              ;restore address.
 jp pe,BinReadLoop   ;If last LDI hits zero, then parity is set.
 ret                 ;exit
#IF FDEBUG=1
.echo "CMD17 "
.echo $-fbinread
.echo ", "
#ENDIF 
#ENDIF
;============================
#IF BINWRITE == 1
fBinWrite:
;Ans bytes from start (DE), Str9=hex string, Str0=file
;Does not check to see if reading past the end of the file.
 call getprogram     ;locate program position in HL
 in a,(6)            ;check if in archive
 or a                ;checking
 jp nz,Err.PRGMARCHIVED ;quit on error condition. Can't write to archived items.
 call getans         ;DE=insertion offset
 add hl,de           ;size+insertion offset. will not invoke carry unless abused
 push hl             ;saving offset for later insertion
  push hl            ;saving offset again for _InsertMem
   ex de,hl          ;for needed subtraction
   ld hl,(EOF)       ;end of file address
   sbc hl,de         ;EOF - CUR. Should never exceed EOF else something is wrong.
   jp c,Err.LINENOTFOUND ;reusing same error code as those found in line read
   call getstr9      ;locate string for its size.
   srl b             ;Divide by two to determine
   rr c              ;# of bytes to insert
   ld h,b            ;load this to HL for _InsertMem
   ld l,c            ;...
   push hl           ;preserve size information
    bcall(_EnoughMem) ;check to see if there's enough memory to insert
   pop hl            ;restore size information
   jp c,Err.NOMEM    ;exit on no memory condition
  pop de             ;restore address to insert at
  push hl            ;preserve size
   bcall(_InsertMem) ;HL=bytes, DE=address
  pop bc             ;restore size to update file with
  call updatesizeins ;update the file's size
  push bc            ;save the size again
   call getstr9      ;get the address of the string at HL
  pop bc             ;restore the size so we don't have to do srl b \ rr c again
 pop de              ;restore insertion address of the file
 ex de,hl            ;put source into DE and destination into HL
BinWriteLoop:        ;
 ld a,(de)           ;get hex digit from source
 inc de              ;increment address in source
 call TextNumInA     ;convert letter to binary
 rlca                ;we got MSN from source. shift to accomodate this
 rlca                ;but this by no means prevents erroneous input
 rlca                ;by using a character outside the range of 0-F
 rlca                ;...
 ld (hl),a           ;save this to destination.
 ld a,(de)           ;load next byte from source, this will be the LSN
 inc de              ;increment address in source
 call TextNumInA     ;convert letter to binary
 or (hl)             ;%11110000 | %00001111 = %11111111. Combines results to
 ld (hl),a           ;form the full byte. Store this back.
 inc hl              ;move to next byte in destination
 dec bc              ;decrement the counter
 ld a,b              ;check to see
 or c                ;if it is now zero.
 jr nz,BinWriteLoop  ;If not, keep looping until it does reach zero.
 ret                 ;exit
#IF FDEBUG=1
.echo "CMD18 "
.echo $-fbinwrite
.echo ", "
#ENDIF 
#ENDIF
;============================
#IF BINDELETE == 1

fBinDelete:
;a+bi=Ans. DE=offset, (ipart)=bytesToDelete
 call getprogram  ;get program position in HL.
 in a,(6)         ;check to see if program is archived.
 or a             ;checking...
 jp nz,Err.PRGMARCHIVED ;throw error condition if it is
 call getans      ;put offset into DE.
 add hl,de        ;add offset and position to form position from which to delete.
 push hl          ;save this position.
  ld bc,(ipart)   ;get the number of bytes to delete.
  add hl,bc       ;add this together.
  ld de,(EOF)     ;get the address of the end of file
  ex de,hl        ;exchange HL and DE so carry is set if # of bytes at end exceeds EOF
  sbc hl,de       ;EOF-current(plusdel)
  jp c,Err.LINENOTFOUND ;throw error condition if trying to delete past end of file.
 pop hl           ;restore the file's position.
 ld d,b           ;load the amount to delete loaded from (ipart) a while back.
 ld e,c           ;...
 push bc          ;save the amount to delete
  bcall(_DelMem)  ;HL=address, DE=bytes. Delete the memory.
 pop bc           ;restore amount that was deleted.
 jp updatesizedel
#IF FDEBUG=1
.echo "CMD19 "
.echo $-fbindelete
.echo ", "
#ENDIF 
#ENDIF

;============================
#IF PROGTOSTRING = 1        ;
fProgToString:
 call getprogram
 ex de,hl
 call makestring+3
 push de
  call getprogram
  ld b,d
  ld c,e
 pop de
 call gethlinc
 ld (de),a
 inc de
 dec bc
 ld a,b
 or c
 jr nz,$-8
 ret

#IF FDEBUG=1
.echo "CMD20 "
.echo $-fprogtostring
.echo " ,"
#ENDIF 
#ENDIF

;==================================================
;==================================================
;==================================================
;== ADDITIONAL EQUATES AND ========================
;===== THE ERROR SYSTEM ===========================
;==================================================
;==================================================
;==================================================
#IF FDEBUG=1
.echo "\n"
#ENDIF


#IF RGROUPHANDLER = 1
RADDDETOHL      .set 1      ;
RGETHLINC       .set 1      ;
RGETPROGRAM     .set 1      ;
#ENDIF

#IF RGETLINE = 1
RGETPROGANDANS  .set 1      ;
RFINDLINE       .set 1      ;
#ENDIF

#IF RGETPROGANDANS= 1
RGETPROGRAM     .set 1      ;
RGETANS         .set 1      ;
#ENDIF

#IF RGETPROGRAM = 1
RGETPROGRAMNAME .set 1      ;
RADDDETOHL      .set 1      ;
RGETHLINC       .set 1      ;
#ENDIF

#IF RGETPROGRAMNAME = 1
RGETSTR9        .set 1      ;
#ENDIF

#IF RGETHLINC = 1
RINCHL          .set 1      ;
#ENDIF

#IF RADDDETOHL = 1
RINCHL          .set 1      ;
#ENDIF

#IF RGETTHETA = 1
RGETANS         .set 1      ;
#ENDIF

#IF RGETANS = 1
RCONVOP1B       .set 1      ;
#ENDIF

#IF RFINDLINE = 1
RINCHL          .set 1      ;
#ENDIF

#IF RCONVERTTTOH = 1
RCONVERTSUMSUB  .set 1      ;
#ENDIF

#IF RCONVERTSUMSUB = 1
RCONVERTSUB     .set 1      ;
#ENDIF

#IF RCONVERTSUB = 1
RTEXTNUMINA     .set 1      ;
#ENDIF

#IF RCONVERTHTOT2B = 1
RCONVERTHTOT1B  .set 1      ;
#ENDIF

#IF RCONVERTHTOT1B = 1
RCONVERTHTOTSUB .set 1      ;
#ENDIF

#IF RCONVERTHTOTSUB = 1
RNUMTEXTINA     .set 1      ;
#ENDIF

.echo "Module Code: "
.echo $-programMiddle
.echo " bytes\n"
programCenter:

#IF ERRSYS = 1
#define PRGMERR(xx,yy) call ProgramErr \ .db xx
#define PRGMELS(xx,yy) call ProgramErr \ .db xx
#ENDIF
#IF ERRSYS = 2
#define PRGMERR(xx,yy) call ProgramErr \ .db yy
#define PRGMELS(xx,yy) call ProgramErr \ .db yy
#ENDIF
#IF ERRSYS = 3
#define PRGMERR(xx,yy)
#define PRGMELS(xx,yy) call ProgramErr \ .db "NS"
#ENDIF


Err.PRGMFOUND:       PRGMERR(":P>IS>FN",":1",0)
Err.NUMSTRING:       PRGMERR(":NUMSTNG",":2",0)
Err.NULLSTRING:      PRGMERR(":NULLSTR",":3",0)
Err.LINENOTFOUND:    PRGMERR(":L>NT>FN",":4",0)
Err.STRNOTFOUND:     PRGMERR(":S>NT>FN",":5",0)
Err.ENTRYTOOLONG:    PRGMERR(":E>2>LNG",":6",0)
Err.STRTOOLONG:      PRGMERR(":S>2>LNG",":7",0)
Err.NULLVAR:         PRGMERR(":NULLVAR",":8",0)
Err.PRGMNOTFOUND:    PRGMERR(":P>NT>FN",":9",0)
Err.PRGMARCHIVED:    PRGMERR(":PGM>ARC",":A",0)
Err.TNOTFOUND:       PRGMERR(":T>NT>FN",":B",0)
Err.NULLLINE:        PRGMERR(":NULLINE",":C",0)
Err.STRARCHIVED:     PRGMERR(":STR>ARC",":D",0)
Err.GROUPNOTFOUND:   PRGMERR(":G>NT>FN",":E",0)
Err.NOMEM:           PRGMERR(":NT>EN>M",":F",0)

Err.NOSUPPORT:       PRGMELS(":SUPPORT","NS",0)

.echo "Errorsystem: "
.echo $-programCenter
.echo " bytes\n"
programRoutines:

ProgramErr:  ;HL already pushed by the call
 call makestring
 pop hl
 ldir
programend:
 ld SP,(stack)
 ld a,(page)
 out (6),a
 ret
#IF RMAKESTRING = 1
#IF RDEBUG = 1
.echo "MKST "
#ENDIF
makestring:
#IF ERRSYS = 1
 ld hl,8
#ELSE
 ld hl,2
#ENDIF
 push hl
  ld hl,Str9
  rst 20h
  rst 10h
  bcallnc(_DelVarArc)
 pop hl
 push hl
  bcall(_CreateStrng)
 pop bc
 inc de
 inc de
 ret
#IF SDEBUG = 1
.echo $-makestring
.echo " "
#ENDIF
#ENDIF

#IF ( RGETSTR9 = 1 ) | ( RGETSIZE = 1 )
#IF RDEBUG = 1
.echo "GST9 "
#ENDIF

getstr9:
 ld hl,Str9
 rst 20h
 rst 10h
 jp c,Err.STRNOTFOUND
 ld a,b
 or a
 jp nz,Err.STRARCHIVED  ;if archived, generate error
 ex de,hl
getsize:
 ld c,(hl)
 inc hl
 ld b,(hl)
 inc hl
 ld a,c
 or b
 ret
#IF SDEBUG = 1
.echo $-getstr9
.echo " "
#ENDIF
#ENDIF

#IF RGETPROGRAMNAME = 1
#IF RDEBUG = 1
.echo "GPGN "
#ENDIF
getprogramname:
 ld hl,Str0
 call getstr9+3  ;skip over the "LD HL,Str9" part
 jp z,Err.NULLVAR  ;Str0 is null. Cannot accept input.
 ex de,hl
 ld hl,-22  ;This number picked to prevent terrible buffer overflow
 add hl,bc  ;Can't be too long.
 jp c,Err.ENTRYTOOLONG
 ld hl,Op1
;===================
#IF FILEAPPVAR = 1 ;
 ld a,(de)         ;
 cp $15            ;rowSwap( token equates to AppVar type
 jr z,skip923      ;jump over in order to copy in the type byte as well
#ENDIF             ;
;========================
#IF FILEGROUP = 1       ;
 bit gGroup,(iy+myflag) ;
 jr z,$+7               ;
 ld a,(de)              ;
 cp $17                 ;*row( token equates to Group type
 jr z,skip923           ;
#ENDIF                  ;
;========================
 ld (hl),$05  ;Prog obj
 inc hl
skip923:
 ex de,hl
;==========================
#IF FILELCASE = 1         ;
 ld b,c                   ;
getprognamesubloop:       ;
 ld a,(hl)                ;
 inc hl                   ;
 cp $BB                   ;
 jr nz,getprognameminloop ;2bytetok skip if not found.
 ld a,(hl)                ;
 inc hl                   ;
 dec b                    ;
 cp $BB                   ;byte not repeated in series. Skipping $BB in series.
 jr c,$+3                 ;because of that, if less than that num, do not alter num
 dec a                    ;
 sub $B0-$61              ;decrease by appropriate number of bytes. Yeah.
getprognameminloop:       ;
 ld (de),a                ;
 inc de                   ;
 djnz getprognamesubloop  ;
#ELSE                     ;
 ldir                     ;straight copy
#ENDIF                    ;
;==========================
 xor a   ;program would not reach this point if A wasn't zero. See "LD A,B" earlier.
 ld (de),a    ;clear out next byte for null-terminated string
 bcall(_ChkFindSym) ;check for program with name retrieved from Str0
;========================
#IF FILEHIDDEN = 1      ;
 jr nc,$+30             ;skip if program info is found. Else, search for hidden
 ld hl,Op1+1            ;
 ld a,(hl)              ;
 add a,-$40             ;
 ld (hl),a              ;
 bcall(_ChkFindSym)     ;
 jr c,$+8               ;
 set Hidden,(IY+myflag) ;
 jr $+12                ;
 push af                ;
  ld a,(Op1+1)          ;
  add a,$40             ;set back to normal
  ld (Op1+1),a          ;
 pop af                 ;
#ENDIF                  ;
;========================
 ret
#IF SDEBUG = 1
.echo $-getprogramname
.echo " "
#ENDIF
#ENDIF

#IF RGETPROGRAM = 1
#IF RDEBUG = 1
.echo "GPGM "
#ENDIF
getprogram:  ;outputs and resets vectors for program data using Str0 stuffs.
 call getprogramname
 jp c,Err.PRGMNOTFOUND    ;kill program with this error if program is not found
 ex de,hl
 ld a,b
 out (6),a
 or a
 jr z,$+15      ;2 skip if already unarchived
 ld de,9        ;3
 call addDEtoHL ;3
 call getHLinc  ;3
 ld e,a         ;1 ,D already set to zero
 call addDEtoHL ;3 = 15
 ld (SOF),hl   ;address at start of size field
 call getHLinc
 ld e,a
 call getHLinc
 ld d,a
 in a,(6)
; ld (SOF+2),a  ;page
 push af
  push hl
   call addDEtoHL  ;add in size and compensate for page stuffs if in Flash
   ld (EOF),hl   ;address
   in a,(6)
   ld (EOF+2),a  ;page
  pop hl
 pop af
 out (6),a
 ret
#IF SDEBUG = 1
.echo $-getprogram
.echo " "
#ENDIF
#ENDIF

#IF RGETHLINC = 1
#IF RDEBUG = 1
.echo "GHLI "
#ENDIF
getHLinc:
 ld a,(hl)
#IF SDEBUG = 1
.echo $-getHLinc
.echo " "
#ENDIF
#ENDIF

#IF RINCHL = 1
#IF RDEBUG = 1
.echo "INHL "
#ENDIF

IncHL:
 bit 7,h
 inc hl
 ret nz
 bit 7,h
 ret z
 push af
  in a,(6)
  inc a
  out (6),a
 pop af
 res 7,h
 set 6,h
 ret
#IF SDEBUG = 1
.echo $-IncHL
.echo " "
#ENDIF
#ENDIF

#IF RADDDETOHL = 1
#IF RDEBUG = 1
.echo "ADDH "
#ENDIF
addDEtoHL:   ;cares for >16384 possibility. Overglorified ADD HL,DE wrt/ pages
 bit 7,h
 push af
  jr nz,addDEtoHLskip
  push bc
   ld c,d
   rlca
   rlca
   and 00000011b  ;get two MSbits of H, and add to page with that
   ld b,a
   in a,(6)
   add a,b
   out (6),a
   ld a,c
   and 11000000b
   ld d,a
  pop bc
addDEtoHLskip: ;old 17;
  add hl,de
 pop af
 jr IncHL+3  ;optimizing in space by reusing an old checking routine
#IF SDEBUG = 1
.echo $-addDEtoHL
.echo " "
#ENDIF
#ENDIF

#IF RGETPROGANDANS = 1
#IF RDEBUG = 1
.echo "GPAA "
#ENDIF
getprogandans:
 call getprogram
#IF SDEBUG = 1
.echo $-getprogandans
.echo " "
#ENDIF
#ENDIF

#IF RGETANS = 1
#IF RDEBUG = 1
.echo "GANS "
#ENDIF
getans:
 push hl
  bcall(_RclAns)  ;obtain ANS var for line input
  call ConvOp1B
  push de
   ld a,(Op1)
   cp $0C         ;complex object
   jr nz,$+12     ;jump over trying to get this
   bcall(_Op2toOp1)
   call ConvOp1B
   ld (ipart),de
  pop de
 pop hl
 ld a,e
 or d   ;# of lines to go thru in DE
 ret
#IF SDEBUG = 1
.echo $-getans
.echo " "
#ENDIF
#ENDIF

#IF RGETTHETA = 1
#IF RDEBUG = 1
.echo "GTHT "
#ENDIF
gettheta:
 push hl
  push bc
   ld hl,theta
   rst 20h
   rst 10h
   jp c,Err.TNOTFOUND
   ld a,b
   or a
   jp nz,Err.TNOTFOUND
   ex de,hl
   rst 20h
  pop bc
  jr getans+4  ;continue with ConvOp1 call in previous routine
#IF SDEBUG = 1
.echo $-gettheta
.echo " "
#ENDIF
#ENDIF

#IF ( RFINDLINE = 1 )
#IF RDEBUG = 1
.echo "FNDL "
#ENDIF
findline:   ;DE=addy (6)=port for page
 ld (pLine),de
 in a,(6)
 ld (pLine+2),a
 ld bc,0
 ld hl,(EOF)
findLineLoop:
 or a
 sbc hl,de
 add hl,de
 jr nz,findLineCont
 in a,(6)
 push bc
  ld bc,(EOF+1)
  sub b
 pop bc
 jr nz,findLineCont
 bit HitEOF,(iy+myflag)
 jr z,$+6
 set ConEOF,(iy+myflag)
 set HitEOF,(iy+myflag)
 ret
findLineCont:
 ex de,hl
 ld a,(hl)
 call IncHL
 ex de,hl
 inc bc
 cp tEnter
 ret z
 jr findLineLoop
 
#IF SDEBUG = 1
.echo $-findline
.echo " "
#ENDIF
#ENDIF

#IF ( RGETLINE = 1 )
#IF RDEBUG = 1
.echo "GTLN "
#ENDIF
getLine:
 call getprogandans  ;HL=addy, DE=ans
 scf
 ret z               ;set carry then exit if ANS==0
 ex de,hl
getLineLoop:
 push hl
  call findLine
 pop hl
 bit ConEOF,(iy+myflag)
 scf
 ret nz
 dec hl
 ld a,h
 or l
 jr nz,getLineLoop
 
 ld hl,(pline)
 ld (temp1),hl
 ld a,(pline+2)
 ld (temp2),a
 ld hl,(ipart)
 inc hl    ;overcome initial zero if imag part is not filled
GetLineLoop2:
 bit ConEOF,(iy+myflag)
 jr nz,GetLineEndFix
 dec hl
 ld a,l
 or h
 jr z,GetLineEnd
 push hl
  push bc
   call findline
  pop hl
  add hl,bc
  ld c,l
  ld b,h
 pop hl
 jr GetLineLoop2
GetLineEndFix:
 res ConEOF,(iy+myflag)  ;do not invoke EOF errors if just reading past
GetLineEnd:
 ld hl,(temp1)
 ld (pline),hl
 ld a,(temp2)
 out (6),a
 bit HitEOF,(iy+myflag)
 jr nz,$+3
 dec bc    ;stripping trailing tEnter if not EOF

 ret
#IF SDEBUG = 1
.echo $-getLine
.echo " "
#ENDIF
#ENDIF

#IF RGROUPHANDLER = 1
#IF RDEBUG = 1
.echo "GPHN "
#ENDIF
GroupGetNext:  ;this is a call to
 push hl
  push de
   ld a,(hl)   ;get type byte
   and $1F     ;clear off masks above
   ld l,a      ;loading to DE
   xor a       ;clear off A to clear off H
   ld h,a      ;clear off MSB of HL
   ld de,OBRT  ;load table of values
   add hl,de   ;get offset in table
   ld l,(hl)   ;get byte indicating relative address
   ld h,a      ;clear off MSB of HL
   add hl,de   ;get address of the routine
  pop de       ;restore DE
  ex (sp),hl   ;exchange the pushed HL with this address HL
 ret           ;pop the address HL off the stack
GetVATDatSt:
 call GrpSymTblColl
 call getHLInc
GetVATDatMerge:
 ld b,a
 ld (nsize),a
 ld de,Op2+1
 call getHLInc
 ld (de),a
 inc de
 djnz $-5
 xor a
 ld (de),a
 call getHLInc
 ld e,a
 call getHLInc
 ld d,a
 ex de,hl      ;DE=address, HL=size
 ret
GetSymTbl:
 call GrpSymTblColl
 ld a,3
 jr GetVATDatMerge
GrpSymTblColl:
 ld a,(hl)
 ld (OP2),a
 ld de,6
 call addDEtoHL
 ret
 
;one-byte type call table
;table start= "OBRT"
;See link guide for types
;and the correct handler
OBRT:
.db HandleReal-OBRT        ;00h=real
.db HandleList-OBRT        ;01h=list
.db HandleMatrix-OBRT      ;02h=matrix
.db HandleString-OBRT      ;03h=equ
.db HandleString-OBRT      ;04g=string
.db HandleProgAppVar-OBRT  ;05h=prog
.db HandleProgAppVar-OBRT  ;06h=protprog
.db HandleString-OBRT      ;07h=pic
.db HandleString-OBRT      ;08h=GDB
.db HandleString-OBRT      ;09h=unknown
.db HandleString-OBRT      ;0Ah=unknown
.db HandleString-OBRT      ;0Bh=window settings
.db HandleCplx-OBRT        ;0Ch=Complex number
.db HandleCplxList-OBRT    ;0Dh=Complex list
.db HandleString-OBRT      ;0Eh=unknown
.db HandleString-OBRT      ;0Fh=window settings
.db HandleString-OBRT      ;10h=saved window settings
.db HandleString-OBRT      ;11h=table setup
.db HandleString-OBRT      ;12h=unknown
.db HandleString-OBRT      ;13h=backup
.db HandleString-OBRT      ;14h=(used to delete flashapps)
.db HandleProgAppVar-OBRT  ;15h=AppVAR
;fill in with rest of values and write routine to use relative values
HandleString:
 call getSymTbl
 jr GroupMultSkip
HandleCplx:
 ld c,16
 jr $+4
HandleReal:
 ld c,7
 call getSymTbl
 ld h,b     ;B=0, set H to 0
 ld l,c
 jr GroupMultSkip
HandleList:
 call getVATDatSt
 jr groupmult9
HandleCplxList:
 call getVATDatSt
; jr groupmult18
GroupMult18:
 add hl,hl
GroupMult9:
 ld c,l
 ld b,h
 add hl,hl
 add hl,hl
 add hl,hl
 add hl,bc
GroupMultSkip:
 ex de,hl
 call addDEtoHL
 or a
 scf
 ret
HandleMatrix:
 call getSymTbl
 ld c,h
 ld h,b
 ld a,l
 add hl,bc
 dec a
 jr nz,$-2
 jr groupmult9
HandleProgAppVar:
 call getVATDatSt
 ex de,hl
 ld (gSOF),hl
 in a,(6)
 ld (gSOF+2),a
 ld (GSIZE),de
 call addDEtoHL
 ld (gEOF),hl
 in a,(6)
 ld (gEOF),a
 or a
 ret

#IF SDEBUG = 1
.echo $-groupgetnext
.echo " "
#ENDIF
#ENDIF


#IF RLOOKUPEOF = 1
#IF RDEBUG = 1
.echo "LEOF "
#ENDIF
lookupEOF:  ;hl=address, DE destroyed; carry set if EOF hit
 ex de,hl
 ld hl,(EOF)
 or a
 sbc hl,de
 scf
 ccf
 ex de,hl
 ret nz
 push bc
  ld a,(EOF+2)
  ld b,a
  in a,(6)
  cp b
 pop bc
 ccf
 ret

#IF SDEBUG = 1
.echo $-lookupEOF
.echo " "
#ENDIF
#ENDIF


;=====================================================
;===================================================
;=====================================================
#IF CDEBUG = 1
#IF RDEBUG = 1
.echo "CDBG "
#ENDIF
debug0:
 DI
 push hl \ push bc \ push de \ push af
 push ix \ push hl \ push de \ push bc \ push af
 ld hl,0 \ ld (currow),hl
 call fastcopy
 pop hl \ call convertHtoT2b \ ld hl,$0020 \ ld (Op6+4),hl \ ld hl,Op6 \ bcall(_PutS) ;AF
 pop hl \ call convertHtoT2b \ ld hl,$0020 \ ld (Op6+4),hl \ ld hl,Op6 \ bcall(_PutS) ;BC
 pop hl \ call convertHtoT2b \ ld hl,$0020 \ ld (Op6+4),hl \ ld hl,Op6 \ bcall(_PutS) ;DE
 bcall(_NewLine)
 pop hl \ call convertHtoT2b \ ld hl,$0020 \ ld (Op6+4),hl \ ld hl,Op6 \ bcall(_PutS) ;HL
 pop hl \ call convertHtoT2b \ ld hl,$0020 \ ld (Op6+4),hl \ ld hl,Op6 \ bcall(_PutS) ;IX
 ld hl,0 \ add hl,sp \ call convertHtoT2b \ ld de,$0020 \ ld (Op6+4),de \ ld hl,Op6 \ bcall(_PutS) ;SP
 bcall(_NewLine)
 in a,(4)    ;waits for ON key to be pressed.
 bit 3,a
 jr nz,$-4   ;keeps program from going anywhere
 in a,(4)    ;waits for ON key to be depressed.
 bit 3,a
 jr z,$-4    ;keeps program from going anywhere
 pop af \ pop de \ pop bc \ pop hl
 ret
#IF SDEBUG = 1
.echo $-debug0
.echo " "
#ENDIF
#ENDIF

;Read and write all inputs and outputs from Op6
;
;To convert single letter of text to single number, use "CALL TextNumInA"
;To convert single number to single letter of text, use "CALL NumTextInA"
;Both routines start with 'A' to work with.
;Original routine used to convert hex to text and vice-versa, but there are
;no checks made for any invalid input, so any higher letter should give appropriate increases.
; Calls:
;ConvertTtoH -- text at (Op6) to hex HL
;ConvertSumSub -- text at (de) to hex A
;ConvertHtoT1b -- hex A to text (Op6)
;ConvertHtoT2b -- hex HL to txt (Op6)
;NumTextInA -- Number to text by nibble (reg A for in and out)
;TextNuminA -- Text to number by nibble (reg A for in and out)
;For nibbles, none of the routines account for overflow or underflow.
ConversionSeries:

#IF RCONVERTTTOH = 1
#IF RDEBUG = 1
.echo "CNV1 "
#ENDIF
ConvertTtoH:  ;text to hexadecimal HL
 push de \ push bc
 ld de,Op6
ConvertTtoHLoop:
 call ConvertSumSub
 ld h,a
 call ConvertSumSub
 ld l,a
 pop bc \ pop de
 ret
#ENDIF

#IF RCONVERTSUMSUB = 1
#IF RDEBUG = 1
.echo "CNV2 "
#ENDIF

ConvertSumSub:
 call convertSub
 ld b,a
 sla b \ sla b \ sla b \ sla b
 call convertSub
 and 00001111b
 or b
 ret
#ENDIF

#IF RCONVERTSUB = 1
#IF RDEBUG = 1
.echo "CNV3 "
#ENDIF
ConvertSub:
 ld a,(de)
 inc de
#ENDIF

#IF RTEXTNUMINA = 1
#IF RDEBUG = 1
.echo "CNV4 "
#ENDIF
TextNumInA:
 cp 'A'
 jr c,$+4
 sub 7
 sub '0'
 ret
#ENDIF

#IF RCONVERTHTOT1B = 1
#IF RDEBUG = 1
.echo "CNV5 "
#ENDIF
ConvertHtoT1b:  ;hexadecimal to text in Op6 from A. Preserves ALL.
 push af \ push hl \ push de
 ld (Op6),a
 ld hl,Op6
 xor a \ rld \ ld e,a \ rld \ ld d,a ; \ rld
; ld hl,Op6
 ld a,e
 call ConvertHtoTSub
 ld a,d
 call ConvertHtoTSub
 pop de \ pop hl \ pop af
 ret
#ENDIF

#IF RCONVERTHTOT2B = 1
#IF RDEBUG = 1
.echo "CNV6 "
#ENDIF
ConvertHtoT2b:  ;hexadecimal to text in Op6 from HL. Preserves ALL. Call to convert 2 bytes of Hexadecimal
 push af \ push hl \ push de
 ld a,L
 call ConvertHtoT1b
 ld a,h
 ld hl,Op6
 ld de,Op6+2    ;moving LSB of text data to Op6+2 for proper read
 ldi
 ldi
 call ConvertHtoT1b
 xor a
 ld (Op6+4),a
 pop de \ pop hl \ pop af
 ret
#ENDIF

#IF RCONVERTHTOTSUB = 1
#IF RDEBUG = 1
.echo "CNV7 "
#ENDIF
ConvertHtoTSub:
 call NumTextInA
 ld (hl),a
 inc hl
 ret
#ENDIF

#IF RNUMTEXTINA = 1
#IF RDEBUG = 1
.echo "CNV8 "
#ENDIF
NumTextInA:
 add a,'0'
 cp '9'+1
 ret c
 add a,7
 ret
#ENDIF
#IF SDEBUG = 1
.echo "[CSER="
.echo $-ConversionSeries
.echo "] "
#ENDIF

#IF RCONVHLTODEC = 1
#IF RDEBUG = 1
.echo "CN2A "
#ENDIF
convHLtoDec:
 ld bc,-10000
 call convHLtoDec1
 ld bc,-1000
 call convHLtoDec1
 ld bc,-100
 call convHLtoDec1
 ld c,-10
 call convHLtoDec1
 ld c,-1
convHLtoDec1:
 ld a,'0'-1
convHLtoDec2:
 inc a
 add hl,bc
 jr c,convHLtoDec2
 sbc hl,bc
 ld (de),a
 inc de
 ret
#IF SDEBUG = 1
.echo $-convHLtoDec
.echo " "
#ENDIF
#ENDIF

#IF RCONVOP1B = 1
#IF RDEBUG = 1
.echo "COP1 "
#ENDIF
ConvOp1B:
 ld hl,0
 ld (tstrn),hl
 ld (tstrn+2),hl
 ld a,(Op1+1)
 sub $80
 jp c,Err.NULLVAR
 cp 5
 jp nc,Err.NULLVAR
 inc a
 ld b,a
 cpl
 add a,6
 ld hl,tstrn
 ld e,a
 ld d,0
 add hl,de
 ld de,Op1+2
ConvOp1BL:
 ld a,(de)
 and $F0
 rlca
 rlca
 rlca
 rlca
 ld (hl),a
 inc hl
 dec b
 jr z,ConvOp1BF
 ld a,(de)
 and $0F
 ld (hl),a
 inc hl
 inc de
 djnz ConvOp1BL
ConvOp1BF:
 call ConvOp1BC
 ex de,hl
 ret
ConvOp1BC:
 ld de,tstrn
 ld hl,0
 ld bc,10000
 call ConvOp1BA
 ld bc,1000
 call ConvOp1BA
 ld bc,100
 call ConvOp1BA
 ld c,10
 call ConvOp1BA
 ld c,1
ConvOp1BA:
 ld a,(de)
 inc de
 or a
 ret z
 add hl,bc
 dec a
 jr nz,$-2
 ret
#IF SDEBUG = 1
.echo $-ConvOp1B
.echo " "
#ENDIF
#ENDIF

#IF RUPDATESIZE = 1
#IF RDEBUG = 1
.echo "UPSZ "
#ENDIF
updatesizedel:   ;update size for delete. Negates BC so becomes HL+(-BC)
 ld a,c
 cpl
 ld c,a
 ld a,b
 cpl
 ld b,a
 inc bc
updatesizeins:   ;size update for insert. (SOF) = start of file, BC= positive
 ld hl,(SOF)
 ld a,(hl)
 add a,c
 ld (hl),a
 inc hl
 ld a,(hl)
 adc a,b
 ld (hl),a
 inc hl
 ret

#IF SDEBUG = 1
.echo $-updatesizedel
.echo " "
#ENDIF
#ENDIF



;================================
#IF RFASTCOPY = 1
#IF RDEBUG = 1
.echo "FSTC "
#ENDIF
fastCopy:
 di
 exx
 ld a,$80            ; 7
 out    ($10),a      ; 11
 out    ($20),a      ; 11 slow down calc if advanced type
 ld hl,plotsscreen-12-(-(12*64)+1)  ; 10
 ld a,$20            ; 7
 ld c,a              ; 4
 inc    hl           ; 6 waste
 dec    hl           ; 6 waste
fastCopyAgain:
 ld b,64             ; 7
 inc    c            ; 4
 ld de,-(12*64)+1    ; 10
 out    ($10),a      ; 11
 add    hl,de        ; 11
 ld de,10            ; 10
fastCopyLoop:
 add    hl,de        ; 11
 inc    hl           ; 6 waste
 inc    hl           ; 6 waste
 inc    de           ; 6
 ld a,(hl)           ; 7
 out    ($11),a      ; 11
 dec    de           ; 6
 djnz   fastCopyLoop ; 13/8
 ld a,c              ; 4
 cp $2B+1            ; 7
 jr nz,fastCopyAgain ; 10/1
 exx
 ret
#IF SDEBUG = 1
.echo $-fastcopy
.echo " "
#ENDIF

#ENDIF
;================================

Str0:  .db $04,$AA,$09,$00
Str9:  .db $04,$AA,$08    ;using next data type as null terminator
theta: .db $00,$5B,$00,$00

#IF RDEBUG = 1
.echo "\n"
#ENDIF

.echo "Subroutines: "
.echo $-programRoutines
.echo " bytes\n"




.echo "-----------------------\n"
.echo "Prgm CELTIC3 size: "
.echo $-programstart
.echo " bytes.\n"
.echo "-----------------------\n"

.end