#include "ti83plus.inc"
.org $9D93
.db $BB,$6D

programstart:
 ld hl,progdata
 rst 20h
 bcall(_ChkFindSym)
 jr nc,Actiontable
 ld hl,1
 bcall(_CreateAppVar)
 inc de
 inc de
 xor a
 ld (de),a
 dec de
 dec de
Actiontable:
 inc de
 inc de
 ex de,hl
 ld a,(hl)
 inc (hl)
 cp $00
 jp z,OneByteTok
 cp $01
 jp z,FirstSeries
 cp $02
 jp z,SecondSeries
 ld (hl),$00
 ld hl,txt4
 call DispString
 ret

OneByteTok:
 ld hl,txt1
 call DispString
 ld b,0
 ld hl,0
OBT1:
 push hl
  push bc
   ld a,b
   ld (invar),a
   xor a
   ld (invar+1),a
   call gettoken
   ld e,a
   ld d,0
  pop bc
 pop hl
 add hl,de
 inc hl
 inc hl      ;to account for the LF/CR chars
 djnz OBT1
 ld a,0
 call makeprog
 ld b,0
OBT2:
 push bc
  push de
   ld a,b
   ld (invar),a
   xor a
   ld (invar+1),a
   call gettoken
   ld c,a
   ld b,0
  pop de
  ldir
  ex de,hl
  call AddNewline
  ex de,hl
 pop bc
 djnz OBT2
 ret

FirstSeries:
 ld hl,txt5
 call DispString

 ret
 
SecondSeries:
 ld hl,txt5
 call DispString
 ret













;gettoklen = HL, pointer to one or two byte token, out A/BC=length of token, HL=address of string
GetToken:  ;write data at internal variable for reading. Output: BC=len, HL=Op3
 ld hl,invar
 bcall(_get_tok_strng)
 ld hl,OP3
 ret
DispString:
 push hl
  ld hl,$0000
  ld (currow),hl
 pop hl
 bcall(_PutS)
 ret
MakeProg: ;A=name,HL=size output: DE=address to start writing
 push hl
  push af
   ld hl,baseTitle
   rst 20h
  pop af
  add a,$30      ;make it a number var
  ld (Op1+2),a
  bcall(_ChkFindSym)
  bcallnc(_DelVarArc)
 pop hl
 bcall(_CreateProg)
 inc de
 inc de
 ret
AddNewLine:
 ld (hl),$0D
 inc hl
 ld (hl),$0A
 inc hl
 ret
 
 

str9:      .db $04,$AA,$08,$00
ProgData:  .db appVarObj,"uTIL DAT",0
baseTitle: .db ProgObj,"U",$00,$00,$00
;               0123456789ABCDEF
txt1:      .db "1 BYTE TOK LIST-",0
txt2:      .db "26 PREFIX LIST  ",0
txt3:      .db "BB PREFIX LIST  ",0
txt4:      .db "LISTING DONE.   "
           .db "RESETTING LISTER",0
txt5:      .db "THIS FUNCTION IS"
           .db "NOT SUPPORTED.  ",0
           
           


invar: .db $00,$00

.end
